/* 2004.11.18 add set_shutter_speed */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#include <ctype.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include "dome.h"

int dome_open()
{
  int fd, flg;
  char rch[64];

  fd=init_sio();
  if(fd<0)
    return DOME_ERR;

  if(sendstr_sio(fd,DOME_OPEN_COM)==DOME_ERR)
    return DOME_ERR;
  printf("dome_open():send: %s",DOME_OPEN_COM);

  /*flushing sio */
  flg = 1;
  while (flg) {
    if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR) {
      printf("# open(): dome sio error.\n");
      //      return DOME_ERR;
      flg++;
      if (flg < 5) {
	printf("dome_open():sleep 1sec.\n");
	sleep(1);
      } else {
	return DOME_ERR;
      }
    } else {
      printf("dome_open():recieve: %s\n",rch);  
      if((strncmp(rch, "EN0022", 6))==0) {
	flg = 0;
      } else {
	flg++;
	if (flg < 5) {
	  printf("dome_open():sleep 1sec.\n");
	  sleep(1);
	} else {
	  return DOME_ERR;
	}
      }
    }
  }

  close_sio(fd);

  return DOME_OK;
}

/* dome_close for DIMM2 
 * 20051122 */
int dome_close()
{
  	int fd;
	char rch[64];

	fd=init_sio();
	if(fd<0)
	  return DOME_ERR;

	if(sendstr_sio(fd,DOME_CLOSE_COM)==DOME_ERR)
		return DOME_ERR;
	printf("dome_close():send: %s",DOME_CLOSE_COM);

	if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
		return DOME_ERR;
	printf("dome_close():recieve: %s\n",rch);
	if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
		return DOME_ERR;
	printf("dome_close():recieve: %s\n",rch);

	close_sio(fd);

	return DOME_OK;
}

/* modified v0.7.0 20041123 iwata */
int dome_status()
{
  int fd,stat, flg;
  char rch[64];

  fd=init_sio();
  if(fd<0)
    return DOME_ERR;

  if(sendstr_sio(fd,DOME_STATUS_COM)==DOME_ERR)
    return DOME_ERR;
  printf("dome_status():send: %s",DOME_STATUS_COM);

  /*flushing sio */
  flg = 1;
  while (flg) {
    if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR) {
      printf("# dome_status(): dome sio error.\n");
      return DOME_ERR;
    }

    printf("dome_status():recieve: %s\n",rch);

    if((strncmp(rch, "ST0022", 6))==0) {
      flg = 0;
    } else {
      flg++;
      if (flg < 5) {
	printf("dome_status():sleep 1sec.\n");
	sleep(1);
      } else {
	return DOME_ERR;
      }
    }
    //	if(sscanf(rch,"ST0022%d\n",&stat)!=1)
    //	{
    //		fprintf(stderr,"dome_status(): format error!\n");
    //		return DOME_ERR;
    //	}
  }
  sscanf(rch,"ST0022%d\n",&stat);

  close_sio(fd);

  return stat;
}

/* added v0.7.0 20041122 iwata */
/* v0.7.1 added ccd power status check */
int ccd_on()
{
  int fd, flg;
  char rch[64];

  fd=init_sio();
  if(fd<0)
    return DOME_ERR;

  // ccd power status check
  printf("ccd_on():send %s", CCD_POWER_STATUS);
  if(sendstr_sio(fd,CCD_POWER_ON)==DOME_ERR)
    return DOME_ERR;

  if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
    printf("# dome sio error.\n");

  flg = 1;
  printf("ccd_on():recieve: %s\n",rch);
  if((strncmp(rch, "ST00100", 7))==0) {
    flg = 0;
  } else {
    flg = 1;
  }

  if (flg) {
    // ccd power on
    printf("ccd_on():send %s",CCD_POWER_ON);
    if(sendstr_sio(fd,CCD_POWER_ON)==DOME_ERR)
      return DOME_ERR;

    /*flushing sio */
    flg = 1;
    while (flg) {
      if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
	printf("# dome sio error.\n");
      
      printf("ccd_on():recieve: %s\n",rch);
      if((strncmp(rch, "EN00101", 7))==0) {
	flg = 0;
      } else {
	flg++;
	if (flg < 5) {
	  printf("ccd_on():sleep 1sec.\n");
	  sleep(1);
	} else {
	  return DOME_ERR;
	}
      }
    }
  }

  // shutter pulse off
  /*
  if(sendstr_sio(fd,SYNC_PULSE_OFF)==DOME_ERR)
    return DOME_ERR;
  printf("ccd_on():send %s",SYNC_PULSE_OFF);

  if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
    return DOME_ERR;
  printf("ccd_on():recieve: %s\n",rch);
  */

  // shutter pulse status check
  if(sendstr_sio(fd,SYNC_PULSE_STATUS)==DOME_ERR)
    return DOME_ERR;
  printf("ccd_on():send: %s",SYNC_PULSE_STATUS);

  if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR) 
    return DOME_ERR;
  printf("ccd_on():recieve: %s\n",rch);
  if (strcmp(rch, SYNC_PULSE_OFF)) {
    // shutter pulse on
    if(sendstr_sio(fd,SYNC_PULSE_ON)==DOME_ERR)
      return DOME_ERR;
    printf("ccd_on():send %s",SYNC_PULSE_ON);

    if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
      return DOME_ERR;
    printf("ccd_on():recieve: %s\n",rch);
  }

  close_sio(fd);

  return DOME_OK;
}


int ccd_off()
{
  	int fd;
	char rch[64];

	fd=init_sio();
	if(fd<0)
		return DOME_ERR;

	// shutter pulse off
	if(sendstr_sio(fd,SYNC_PULSE_OFF)==DOME_ERR)
		return DOME_ERR;
	printf("ccd_off():send %s",SYNC_PULSE_OFF);

	if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
		return DOME_ERR;
	printf("ccd_off():recieve: %s",rch);

	// ccd power off
	if(sendstr_sio(fd,CCD_POWER_OFF)==DOME_ERR)
		return DOME_ERR;
	printf("ccd_off():send %s",CCD_POWER_OFF);

	if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
		return DOME_ERR;
	printf("ccd_off():recieve: %s",rch);

       close_sio(fd);

	return DOME_OK;
}

int set_shutter_speed(char* sp)
{
  int fd;
  char sch[10];
  char rch[64];

  fd=init_sio();
  if(fd<0)
    return DOME_ERR;

  strncpy(sch, SET_SHUTTER_INT,6);
  sch[6] = sp[0];
  sch[7] = sp[1];
  sch[8] = sp[2];
  sch[9] = sp[3];
  sch[10] = '\0';

  // set speed
  #ifdef DEBUG
  printf("  set_shutter_speed():send %s\n", sch);
  #endif
  if(sendstr_sio(fd, sch) == DOME_ERR)
    return DOME_ERR;

  // MV0025 does not have response
  //  if (recievestr_sio(fd,rch,sizeof(rch)) == DOME_ERR)
  //    return DOME_ERR;

  // shutter pulse off
  #ifdef DEBUG
  printf("  set_shutter_speed():send %s\n",SYNC_PULSE_OFF);
  #endif
  if(sendstr_sio(fd,SYNC_PULSE_OFF)==DOME_ERR)
    return DOME_ERR;

  if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
    return DOME_ERR;
  #ifdef DEBUG
  printf("  set_shutter_speed():received: %s\n",rch);
  #endif

  usleep(100000);

  // shutter pulse on
  #ifdef DEBUG
  printf("  set_shutter_speed():send %s",SYNC_PULSE_ON);
  #endif
  if(sendstr_sio(fd,SYNC_PULSE_ON)==DOME_ERR)
    return DOME_ERR;

  if(recievestr_sio(fd,rch,sizeof(rch))==DOME_ERR)
    return DOME_ERR;
  #ifdef DEBUG
  printf("  set_shutter_speed():received: %s",rch);
  #endif

  close_sio(fd);

  return DOME_OK;
}


int init_sio()
{
	int fd;
	struct termios	tio;

	if((fd=open(SIOPORT,O_RDWR))<0)
	{
		perror("open");
		return DOME_ERR;
	}

	if((int)tcgetattr(fd,&tio)<0)
	{
		perror("tcgetattr");
		return DOME_ERR;
	}

	cfsetispeed(&tio,B19200);
	cfsetospeed(&tio,B19200);

	tio.c_cflag &= ~CBAUD; //clear BAUD flags
	tio.c_cflag |= B19200;
	tio.c_cflag &= ~CSIZE; //clear data bits size flags
	tio.c_cflag |= CS8; //8bit
	tio.c_cflag |= CSTOPB; //stop bit=2bit
	tio.c_cflag &= ~PARENB; //disable parity bit
	tio.c_cflag |= CLOCAL; //ignore modem status lines

	tio.c_iflag &= ~IXON; //disable software flow control
	tio.c_iflag &= ~IXOFF; //disable software flow control

	tio.c_oflag &= ~ONLCR;

	tio.c_lflag &= ~ECHO; //disable echoing of input characters
	tio.c_lflag &= ~ICANON; //disable canonical input

	tio.c_cc[VMIN]=0; // set control characters
	tio.c_cc[VTIME]=1;

	if((int)tcsetattr(fd,TCSANOW,&tio)<0)
	{
		perror("tcsetattr");
		return DOME_ERR;
	}

	if((int)tcgetattr(fd,&tio)<0)
	{
		perror("tcgetattr");
		return DOME_ERR;
	}

	return fd;
}

int close_sio(int fd)
{
	if(close(fd)<0)
	{
		perror("close");
		return DOME_ERR;
	}

	return DOME_OK;
}

int sendchar_sio(int fd, char ch)
{
	if(write(fd,&ch,1)<0)
	{
		perror("write");
		return DOME_ERR;
	}

	return DOME_OK;
}

int sendstr_sio(int fd, char *str)
{
	int	n,nwritten;
	char	*com;

	n=strlen(str);
	com = (char *)malloc(sizeof(char)*(n+2));

	if(strchr(str,'\n')==NULL)
		sprintf(com,"%s\n",str);
	else
		strcpy(com,str);

	nwritten = write(fd,com,strlen(com));
	if(nwritten<0)
	{
		perror("write");
		return DOME_ERR;
	}

	return nwritten;
}

int recievechar_sio(int fd, char *ch)
{
	fd_set rset;
	struct timeval tv;

	FD_ZERO(&rset);
	FD_SET(fd,&rset);

	tv.tv_sec = SIO_WAIT;
	tv.tv_usec = 0;
	if(0<select(FD_SETSIZE,&rset,NULL,NULL,&tv)) {
		if(FD_ISSET(fd,&rset)) {
			if(read(fd,ch,1)<0) {
				perror("read");
				return DOME_ERR;
			}
		}
	}
	else
	{
		fprintf(stderr,"recievechar_sio(): SIO timed out\n");
		return DOME_ERR;
	}

	return DOME_OK;
}

int recievestr_sio(int fd, char *ch, int nchar)
{
	int nread;
	fd_set rset;
	char cp;
	struct timeval tv;

	FD_ZERO(&rset);
	FD_SET(fd,&rset);

	tv.tv_sec = SIO_WAIT;
	tv.tv_usec = 0;
	if(0<select(FD_SETSIZE,&rset,NULL,NULL,&tv)) {
		nread=0;
		if(FD_ISSET(fd,&rset)) {
			ch[0]='\0';
			while(nread<nchar)
			{
				if(read(fd,&cp,1)<0)
				{
					perror("read");
					return DOME_ERR;
				}
				nread++;
				if(cp=='\n')
					break;
				sprintf(ch,"%s%c",ch,cp);
			}
		}
	}
	else
	{
		fprintf(stderr,"recievestr_sio(): SIO timed out\n");
		return DOME_ERR;
	}

	return nread;
}

/* read sio until timed-out */
/* 20041124 iwata */
int flush_sio(void)
{
  char ch[20];
  int nchar = 20;
  int nread, fd;
  fd_set rset;
  char cp;
  struct timeval tv;

  fd = init_sio();

  FD_ZERO(&rset);
  FD_SET(fd,&rset);

  tv.tv_sec = SIO_WAIT;
  tv.tv_usec = 0;
  while(0<select(FD_SETSIZE,&rset,NULL,NULL,&tv)) {
    nread=0;
    if(FD_ISSET(fd,&rset)) {
      ch[0]='\0';
      while(nread<nchar) {
	if(read(fd,&cp,1)<0) {
	  perror("read");
	  return DOME_ERR;
	}
	nread++;
	if(cp=='\n')
	  break;
	sprintf(ch,"%s%c",ch,cp);
      }
    }
  }

  close_sio(fd);
  return nread;
}
