/* finder_watch
 *  check status of finder using fork
 * 20041105 modified
 * 20041122 auto-mode added
 * Time-stamp: <2005-01-28 17:30:25 dimm>
 */
#include <sys/types.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>

int flg, rflg;

void receiv_term(int sig);

int main( int   argc,
          char *argv[] ) {
  pid_t pid, child_pid;
  int ret, stat_val, autoflg, opt;

  rflg = 0;
  flg = 1;
  autoflg = 0;

  while ((opt = getopt(argc, argv, "a")) != -1) {
    switch (opt) {
    case 'a':
      autoflg = 1;
      printf("# finder_watch: auto-starting mode.\n");
      break;
    }
  }


  while (flg) {
    pid = fork();

    switch(pid) {
    case -1:
      exit(1);
    case 0: /* child */
      flg = 0;
      if (autoflg) {
	ret = system("/usr/local/bin/finder -a");
      } else {
	printf("### rflg is %d.\n", rflg);
	if (rflg) {
	  /* restarting finder */
	  //	  ret = system("/usr/local/bin/finder -r");
	  /* force auto-mode */
	  ret = system("/usr/local/bin/finder -ar");
	} else {
	  ret = system("/usr/local/bin/finder");
	}
	//    printf("child: go to sleep.\n");
	//    system("sleep 30");
	//    execl("/bin/sleep", "sleep","30",0);
      }
      printf("### finder exit status: %d\n", ret);
      if (ret != 0) {
	child_pid = getppid();
	kill(child_pid, SIGALRM);
	printf("### finder_watch:child: sent SIGALRM to %d.\n", child_pid);
      }
      break;
    default: /* parent */      
      flg = 0; /* end unless SIGALRM received */
      rflg = 1;

      (void)signal(SIGALRM, receiv_term);
      
      child_pid = wait(&stat_val);
      printf("### finder_watch: child %d terminated with code %d.\n", 
	     child_pid, stat_val);
      ret = 0;
      break;
    }
  }

  exit(ret);
}

void receiv_term(int sig) {
  printf("### received signal. %d\n", sig);
  flg = 1; /* go on */
}
