/* 
 * preferences panel 
 *
 * 2003.01.23 -
 * Time-stamp: <2004-11-29 17:42:21 dimm>
 *
 */

#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#include "finder.h" /* 2003.03.11 for finder */

void dialog_setup_destroy (GtkWidget *widget, gpointer data);
void dialog_setup_click_cancel (GtkWidget *widget, gpointer data);
void dialog_setup_click_ok (GtkWidget *widget, gpointer data);

/* initialization of pref. panel
 *
 */
int init_setup_dialog(GtkWidget *dialog_setup) {
  GtkWidget *button;
  GtkWidget *label1;
  GtkWidget *hbox1, *vbox1;
  GtkWidget *action_area1;
  GtkWidget *entry1;

  int deg, min, sec;
  int decimal, sign;
  gchar str[4];
  //  gchar *buffer;

  gtk_window_set_policy(GTK_WINDOW(dialog_setup), FALSE, FALSE, TRUE);

  hbox1 = gtk_hbox_new (FALSE, 0);
  vbox1 = GTK_DIALOG(dialog_setup)->vbox;
  action_area1 = GTK_DIALOG(dialog_setup)->action_area;


  /* time for reload image */
  label1 = gtk_label_new("DV Reload Interval ");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  ent_intv = gtk_entry_new();
  gtk_entry_set_width_chars(GTK_ENTRY(ent_intv), 4);
  sprintf(str, "%d", mseemon.time_reload);
  gtk_entry_set_text(GTK_ENTRY(ent_intv), str);
  gtk_widget_show(ent_intv);
  gtk_box_pack_start(GTK_BOX(hbox1), ent_intv, TRUE, FALSE, 1);
  label1 = gtk_label_new("msec");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(hbox1), label1, FALSE, FALSE, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);


  /* action area */
  hbox1 = gtk_hbox_new (FALSE, 0);

  /* cancel button */
  button = gtk_button_new_with_label ("Cancel");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_setup_click_cancel), dialog_setup);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  /* ok button */
  button = gtk_button_new_with_label ("Ok");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_setup_click_ok), dialog_setup);
  gtk_box_pack_start(GTK_BOX (hbox1), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  gtk_box_pack_start(GTK_BOX(action_area1), hbox1, TRUE, TRUE, 2);
  gtk_widget_show(hbox1);

  gtk_widget_show(vbox1);
  gtk_widget_show(dialog_setup);

  return 0;
}

/******
 * callback functions for this dialog 
 ******/

/* close dialog */
void dialog_setup_destroy (GtkWidget *widget, gpointer data)
{
  gtk_grab_remove(widget);
  //  gtk_widget_destroy(GTK_WIDGET(data));
  gtk_widget_destroy((GtkWidget*)data);
}

/* click cancel */
void dialog_setup_click_cancel (GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

/* click ok
 * set interval, site lon and lat */
void dialog_setup_click_ok (GtkWidget *widget, gpointer data)
{
  gchar text[128];
  gchar* content;
  int i, d, m, s;
  double val;

  content = (gchar*)gtk_entry_get_text(GTK_ENTRY(ent_intv));
  d = atoi(content);
  mseemon.time_reload = d;

  /* check reload interval 
   * added ver.0.6.1 2003.10.02 */
  if (mseemon.time_reload < 500) {
    printf("reload interval too short. should be longer than 499msec.\n");
    mseemon.time_reload = 500;
  }

  #ifdef DEBUG
  printf("New Reload Interval:    %d msec.\n", mseemon.time_reload);
  /*
  printf("New Reset Sky Interval: %d times.\n", mseemon.time_sky);
  printf("New Rect. Size: %d x %d.\n", mseemon.star_rect[0].cx, mseemon.star_rect[0].cy);
  printf("New Bg-Sub Sigma: %4.1f\n", bgthr);
  printf("New Site Location: lon:%8.4f lat:%8.4f\n", msite.slon, msite.slat);
  */
  #endif

  /* reset timer */
  if (mseemon.is_auto) {
    if (timertag != -1) {
      /* stop current working timer */
      auto_stop_capture();
    }
    auto_start_capture();
  } else {
    if (mseemon.is_capturing) { /* if capture window is open */
      if (timertag != -1) {
	/* stop current working timer */
	stoptimer();
      }
      starttimer();
    }
  }

  gtk_widget_destroy(GTK_WIDGET(data));
}

